//#define grid 10

import processing.serial.*;

Serial myPort;      // The serial port
//PFont font;

int xpos;
int grid = 10;
int yMenu = 20;

long previousMillis = 0;        
long interval = 250;           // interval at which to blink (milliseconds)

boolean displayVolt = false;


void setup() {
  size(400, 300 ,P2D);
  
  // List all the available serial ports:
  println(Serial.list());

  // I know that the first port in the serial list on my mac
  // is always my  FTDI adaptor, so I open Serial.list()[0].
  // In Windows, this usually opens COM1.
  // Open whatever port is the one you're using.
  String portName = Serial.list()[0];
  myPort = new Serial(this, portName, 9600);
  
  // Uncomment the following two lines to see the available fonts 
  //String[] fontList = PFont.list();
  //println(fontList);
  //font = createFont("Comic Sans MS", 36,true);
  //textFont(font, 12);
  
  newBackground();  
  smooth();
}

void serialEvent (Serial myPort) {
   // get the ASCII string:
   String inString = myPort.readStringUntil('\n');
   float xdata1,xdata2;
   
   if (inString != null) {
     // trim off any whitespace:
     inString = trim(inString);
   
     String[] data = splitTokens(inString, ",");
     
     float RH = float(data[0]);  
     float vRHdata = map(RH, 0, 1023, 0, 5);
     float RHdata = 34.112*vRHdata -20.388;  
   
     float Temp = float(data[1]);
     float vtData = map (Temp, 0, 1023, 0, 5);
     float tData = 19.322* vtData - 21.722;
   
     xpos++;
 
     // convert to an int and map to the screen height:
     if (displayVolt) {
         xdata1 = map(vRHdata, 0, 5, 0, ((height-yMenu)/2) );
         xdata2 = map(vtData, 0, 5, 0,  ((height-yMenu)/2) );     
     } else {
         xdata1 = map(RHdata, 0, 100, 0, ((height-yMenu)/2) );
         xdata2 = map(tData, 0, 100, 0, ((height-yMenu)/2) );
     }
     stroke(255);
     point(xpos,(height/2)+ yMenu - xdata1 );   

     stroke(127);
     point(xpos,(height/2)+ yMenu - xdata2 );   

    // update value text every interval
    // for help stop blinking screen
    if (millis() - previousMillis > interval) {
       previousMillis = millis();   
       fill(255);
       rect(0,0,width,25);
       
       fill(0);  
       text( nf(vRHdata, 1, 3) +" V" , 1, 12);
       text("%RH= "+ nf(RHdata,2,1) , 200, 12);

       text( nf(vtData, 1,3)  +" V" , 1, 25);
       text("TEMP= "+ nf(tData,2,1), 200, 25);
    }
  
    if (xpos > width) {    
       newBackground();
    }
 }
 
}
 
void draw() {

}

void mousePressed() {

}

void keyPressed() {
  // control display volt or convert func
  switch(key) {
  case '1':
    displayVolt = true;
    newBackground();
    break;
  case '2':
    displayVolt = false;
    newBackground();  
    break;
  }
}

void newBackground()
{
  // make grid background
  xpos = 0;
  background(0);
  

  stroke(127,0,0);  
  line(0,(height/2+yMenu),width,(height/2+yMenu));
  
  stroke(85);
  for(int x=0; x< (width/grid); x++) {
    for (int y=0 ; y< (height/grid); y++) {
      point (x*grid,y*grid);
    }
  }

}


/* 
//example code in arduino scope 


void setup() {
  // initialize the serial communication:
  Serial.begin(9600);
}

void loop() {
  Serial.print(analogRead(0));
  Serial.print(",");
  Serial.println(analogRead(1));
  //delay(10);
}

*/
